<br clear="all" />

<div id="helpDiv">

	<div id="helpHeader">
		<span class="help-header">NBA Query scratchpad help</span> <span class="link windowClose" onclick="gui.toggleHelp();">X</span><br />
	</div>

	<div id="helpBody">
		<p>
			<span class="section-header">General</span>
			This tool helps you to build queries for the Netherlands Biodiversity API (NBA), execute them, and store them for re-use. It is not a true query-builder, but rather a collection of functions that makes it easier to understand what a query should look like, helps you construct and test them, and examine their resulting output. Before you start, it might be good to get acquainted with the NBA:
			<ul>
			  <li><a href="http://docs.biodiversitydata.nl/" target="_blank">docs.biodiversitydata.nl</a></li>
			  <li><a href="https://bioportal.naturalis.nl/api?language=en" target="_blank">API description in BioPortal</a></li>
			</ul>
			If you want to use the NBA directly, it can be accessed at <a href="" class="directNbaPath" target="_blank"></a>.
		</p>

		<p>
			<span class="section-header">About this help</span>
			You can click and drag the header to move this window to a position of your liking. Click the 'X' top right to close. Click and hold  <span class="help-highlight">marked items</span> to highlight the corresponding item in the main screen.
		</p>

		<p>
			<span class="section-header">Writing & running queries</span>
			<span class="help-highlight">Service list</span><br />
			List of available endpoints in the API. Endpoints are grouped by document type: specimen, taxon, multimedia, geo or other. For most endpoints, a short description of the service's function is shown when you hover with the mouse over the item in the list. Some items additionally display one or more icons:
			<ul>
				<li><span class="icon-list-item">&#128065;</span>: service accepts 'simple' type queries (using only querystring-parameters)</li>
				<li><span class="icon-list-item">&#8211;</span>: service accepts no query</li>
				<li><span class="icon-list-item">&#8265;</span>: service has explain-option</li>
			</ul>
			'Simple type' queries have the form <code>parameter=value</code> (for instance: <code>collectionType=Aves</code>), whereas regular queries have a more complex form. There are templates available to help you on your way with more complex queries; see the section 'Inserting query-elements' below.<br />
			Explainable services can be called with an added 'explain' parameter that changes the regular output to a breakdown of the steps that lead to that output. Check <span class="help-highlight">add explain</span> to enable.
		</p>
		<p>
			<span class="help-highlight">Server link</span>: link to the root of the NBA server.
		</p>
		<p>
			<span class="help-highlight">Query window</span><br />
			Window for writing the query you want to run. This can be either a JSON-object (for querySpec-queries) or a query-string (for human readable queries). Specify just the actual query, not the rest of the URL (or the '?') - these are inferred from the values selected in the <span class="help-highlight">service list</span>. When you first open this page, two example queries will be automatically added to the list of <span class="help-highlight">saved queries</span> to give you an idea what they look like.<br />
			Queries can be spread across multiple lines (for readability). Empty lines will be ignored, and lines that start with one of these character(s): <span id="exampleCommentChars"></span>  will be treated as comment and ignored.
		</p>
		<p>
			<span class="help-highlight">Execute query</span>
			<br />
			Click the <span class="help-highlight">execute query</span>-button to run your query. When you click the button, the program will, in short:
			<ol>
				<li>Take the selected entry from the <span class="help-highlight">service list</span>;</li>
				<li>If the service requires a query, take the contents of the <span class="help-highlight">query window</span>, and encode them if required. If the selected service does not require a query, the contents of the query window are ignored;</li>
				<li>Put them all together to turn it into a NBA-query;</li>
				<li>Print the the complete <span class="help-highlight">resulting URL</span>;</li>
				<li>Execute the query and print the formatted result in the <span class="help-highlight">result window</span>.</li>
			</ol>
		</p>
		<p>
			Notes:<br />
			<ul>
				<li>The program will not check the validity of your query. If your query is of the complex type, the program <i>will</i> check whether it is valid JSON, but it does not perform any checks beyond that; these are left to the NBA itself. If errors occur there, these are displayed as output.</li>
				<li>The program does not check whether your query actually makes sense with the selected service. If for instance you combine a JSON-query with a human readable service, the program will execute the query all the same, which will generate an error as output.</li>
				<li>The URL printed in the <span class="help-highlight">resulting URL</span> window is not literally what is executed. The http method used by the program for excution depends on the methods that the selected services accepts. Most services accept both GET and POST, in which case the program defaults to POST. In either case, the endpoint of the selected service and the query are posted back to a proxy server, which constructs a request and performs the actual execution. You can force the program to use a specific method by selecting a specific <span class="help-highlight">http request method</span> in the <span class="help-highlight">additional options</span> panel.
				</li>
			</ul>
		</p>
		<p>
			<span class="help-highlight">Query window manipulation</span><br />
			<span class="section-sub-header no-top-margin">Inserting query-elements</span><br />
			Right-click in the <span class="help-highlight">query window</span> to see the <span class="help-highlight">edit</span>, <span class="help-highlight">operators</span> and <span class="help-highlight">queries</span> menus. Hover over the menu title to access each menu's options.
			Select and click an item from <span class="help-highlight">queries</span> to insert it into the <span class="help-highlight">query window</span> at the cursor position, or over selected text.
			Inserting <span class="help-highlight">operators</span> works the same way.<br />

			<b class="section-sub-header">Finding document fields</b><br />
			Type the (partial) name of a field in the <span class="help-highlight">type to find field name</span>-input to find a field. As you type, a droplist will appear displaying all fields matching your search term (type a space to see all available fields). Only fields that match the document type of the selected service will be displayed. Click an item to insert it into the <span class="help-highlight">query window</span> at the cursor position,  or over the selected text. The droplist items include the name of the document type, as well as the fields' datatype and analyzers; these won't be inserted into the query window).<br />
			Fields are matched with each part of your search string, which is split by spaces. For instance, searching for <i>ers gath name</i> will match every line that has the strings 'ers', 'gath' and 'name' anywhere in their name, such as "<u>gath</u>eringEvent.gatheringP<u>ers</u>ons.full<u>Name</u>".<br />
			By default, datatypes and operators are excluded from the search process; by checking <span class="help-highlight">include datatypes and analyzers in search</span> you can include them in your search (for instance if you are looking for a field of a specific datatype). Check <span class="help-highlight">show fields for all document types</span> to see results for all document types, not just the one corresponding with the selected service.<br />

			<b class="section-sub-header">Manipulating text in query window</b><br />
			Use <span class="help-highlight">decode query</span> to decode the contents of the <span class="help-highlight">query window</span>, useful when you want to investigate a query but only have the full url.<br />
			To copy the query to the clipboard, click <span class="help-highlight">copy query</span>. Double clicking does the same and additionally adds <code>{code}</code> tags around the copied content for readable pasting into JIRA.<br />
			Click <span class="help-highlight">copy query +</span> to copy all query elements to the clipboard. (Note: holding down Ctrl while clicking any of the copy-links will additionally log the copied content to the browsers's console).<br />
			To clear the <span class="help-highlight">query window</span>, click <span class="help-highlight">clear query</span>.<br />
			If the query window has focus, use Ctrl + F11 to insert a comment char in query-window at the cursor; also works on multiple selected lines (adds them at the beginning of each line), and Ctrl + F12 to enclose selected text in the query-window in double quotes; also works with multiple words (detects word boundaries).
		</p>
		<p>
			<span class="help-highlight">Resulting URL</span> & <span class="help-highlight">run altered query</span><br />
			The <span class="help-highlight">resulting URL</span>-window shows the resulting URL that the application sends to the NBA. You can directly edit the URL and execute the result by clicking <span class="help-highlight">run altered query</span> (button becomes available once you've actually changed the URL). This is intended for quick debugging purposes; please note that your edits will be lost the next time you run <span class="help-highlight">execute query</span>.
		</p>
		<p>
			<span class="help-highlight">Query run options</span> (available once you have executed a query)<br />
			<ul>
				<li><span class="help-highlight">open directly</span>: opens the last executed URL directly in a new browser window.</li>
				<li><span class="help-highlight">full screen</span>: show the results window full screen. Press Escape to close again.</li>
				<li><span class="help-highlight">copy URL</span>: copies the last executed URL to the windows clipboard.</li>
				<li><span class="help-highlight">copy Scratchpad URL + query</span>: copy a shareable link to Scratchpad including query and selected service.</li>
				<li><span class="help-highlight">clear results</span>: clear the result window.</li>
				<li><span class="help-highlight">copy results</span>: copy the results (can be limited by size; use download for full set). Follows the current result view (JSON or TSV)</li>
				<li><span class="help-highlight">download results</span>: download the results. Follows the current result view (JSON or TSV)</li>
				<li><span class="help-highlight">switch result view</span>: switch between JSON and table view.</li>
				<li><span class="help-highlight">rotate table</span>: rotate the results table (table view only).</li>
			</ul>
		</p>
		<p>
			<span class="help-highlight">result window</span><br />
			Results of your query from the NBA-server.
			You can <span class="help-highlight">switch view</span> between JSON and tabular data.
		</p>
		<p>
			<span class="section-header">Saving queries and executing saved queries</span><br />
			<span class="section-sub-header no-top-margin">Note on saved queries</span><br />
			Saved queries are stored in the local storage of your browser. This means they will be available across browser sessions, but are subject to whatever the browser does to its own Local Storage. Emptying your cache will most likely not cause any problems, nor will upgrading your browser. However, re-installing or performing a factory reset or 'fresh up' of your browser will probably cause your saved queries to be deleted. There are, however, several options for exporting and backing up stored queries.<br />
			Saved queries will not be available when running a private or incognito session, but they will still be there when you start a regular session. Saved queries are not available across different types of browsers, but you can export them from one end import in another.
		</p>
		<p>
			<span class="help-highlight">Query name to save</span><br />
			Enter the name under which you want to save your query. Max. Length is 64 characters. You can clear the input by clicking the <span class="help-highlight">clear query name</span>-symbol.<br />
			Prefix your query with a name between straight bracket to create a group of queries. Creating queries <code>[TEST] query a</code> and <code>[TEST] query b</code> will create a group called 'TEST' containing queries 'query a' and 'query b'. You can collapse groups in the query list, which helps maintain overview.
		</p>
		<p>
			<span class="help-highlight">Save query</span><br />
			Click <span class="help-highlight">save query</span> to save the content of the <span class="help-highlight">query window</span> with the <span class="help-highlight">query name to save</span>. The application will also save a reference to the service that is selected in the <span class="help-highlight">service list</span> at the moment you save the query. If, for whatever reason, you don't want the service to be saved as well, uncheck the <span class="help-highlight">save including service</span> checkbox before you click save.<br />
			The query will be saved in your local browser storage, and will remain available across sessions. If you choose a name that already exists, the application will <u>overwrite</u> the existing query without warning.<br />
			The application will show a message stating the result of the save action, above the query name-input (<a href="#" onclick="setMessage('hi there!');return false;">see what a message looks like</a>). It will also automatically update the list of <span class="help-highlight">saved queries</span>.<br />
			please note, the application <i>only</i> saves the query and the service, <u>not</u> the server. So if you load a saved query, you'll have to manually select the appropriate server to run it against.
		</p>
		<p>
			<span class="help-highlight">Saved queries</span><br />
			List of saved queries. Legend to the various symbols:
		</p>

		<p class="inner-p">
			<table class="symbolTable">
				<tr>
					<td><span class="arrow-use-query-and-service">&#10229;</span></td>
					<td>
						Load the saved query into the <span class="help-highlight">query window</span> and set the saved service in the <span class="help-highlight">service list</span>. Hover over the symbol to see the name of the saved service. Click while holding down Ctrl to cause the query to be executed after loading.
					</td>
				</tr>
				<tr>
					<td><span class="symbol min-width-symbol">x</span></td>
					<td>Delete the query (asks confirmation).</td>
				</tr>
				<tr>
					<td><span class="symbol min-width-symbol">&#128203;</span></td>
					<td>Copy the query name to the <span class="help-highlight">query name to save</span> input. Handy when you want to overwrite an existing saved query. Clicking one next to a group copies that group's name to the input, so you can more easily save a query as part of that group.</td>
				</tr>
				<tr>
					<td><span class="symbol min-width-symbol">&equiv;</span></td>
					<td>Open query notes (see below).</td>
				</tr>
				<tr>
					<td><span class="symbol min-width-symbol">&#8795;</span></td>
					<td>Same, but query already has some saved notes (hint indicates note length).</td>
				</tr>
				<tr>
					<td><span class="symbol min-width-symbol">&boxbox;</span></td>
					<td>Indicates a group of queries. Click to expand. The number indicates the number of queries in the group.</td>
				</tr>
			</table>
			When you have no saved queries, the application automatically creates a set of example queries.
		</p>
		<p>
			<span class="help-highlight">Query notes</span><br />
			The application allows you to store notes with a query. Click on one of the <span class="symbol link min-width-symbol">&equiv;</span>-symbols to open a popup with the notes for that query. You can have only one set of notes open at a given time. Clicking a second <span class="symbol link min-width-symbol">&equiv;</span>-symbol while notes are already open will automatically save before opening the next set of notes. Notes are deleted automatically when you delete the corresponding query.<br />
			The <span class="help-highlight">note title</span> is the same as the query the note belongs to. The number after the title indicates the size of the note (not sure if there's a maximum).<br />
			Type your text in the <span class="help-highlight">notes input area</span> (which opens with existing notes if there are any) and click <span class="help-highlight">save notes</span> to save the notes. To delete, clear the entire input and click save.<br />
			Click <span class="help-highlight">insert timestamp</span> to insert the current date and time at the cursor position. Click <span class="help-highlight">insert line</span> to insert the current date and time at the cursor position. Click <span class="help-highlight">close note</span> to close the notes popup.<br />
			If there's a valid URL in the notes, you can select it to make a clickable link-icon <span class="symbol">&#8599;</span> appear in the notes window's header (obviously an actual hyperlink would be more practical, but the notes are in a textarea, which doesn't render html).
		</p>
		<p>
			<span class="help-highlight">Query export</span><br />
			Click <span class="help-highlight">export all queries</span> to have scratchpad automatically download a backup of all your queries to the browser's downloads-folder. See below for automated backups.
		</p>
		<p>
			<span class="help-highlight">Additional options</span><br />
			Click the <span class="help-highlight">additional options</span>-icons (<span class="symbol">&#9660;</span> <span class="symbol">&#9650;</span>) to toggle the maintenance options.<br /><br />

			Use <span class="help-highlight">query backup file import</span> to import queries from a previous backup file. By checking <span class="help-highlight">enable automatic monthly query-backup</span>, the program will automatically back up your saved queries to the browser's downloads-folder (note: works only if you actually use the scratchpad once in a while).<br /><br />

			Use <span class="help-highlight">export selected queries</span> to export selected queries as a JSON-string. When you open <span class="help-highlight">additional options</span>, checkboxes (<span class="symbol link off">&#9744;</span> <span class="symbol link on">&#9745;</span>) appear for each item in the <span class="help-highlight">saved queries</span> list. Use the <span class="help-highlight">select all</span> and <span class="help-highlight">select none</span> links to change the selection in bulk. Select the queries you want to export, and click <span class="help-highlight">export selected queries</span>. The corresponding JSON-string is written to the <span class="help-highlight">query window</span> (notes, if any, are included. Services are not). Select and copy the JSON-string from the window and save it as backup in a regular txt-file, or share it with other users. Paste an exported JSON-string into the <span class="help-highlight">query window</span> and click <span class="help-highlight">import queries</span> to import the queries. All queries are imported; if another query with the same name already exist, a number is added to the name of the newly imported query.<br /><br />

			Use <span class="help-highlight">delete selected queries</span> in combination with the checkboxes in the <span class="help-highlight">saved queries</span> list to delete queries in bulk (after confirmation).<br /><br />

			Click <span class="help-highlight">query timer</span> to bring up the query execution timer. The timer counts the delay between the moment the full query is launched, and the moment the results come back (more precise, between the moment the src-attribute of the result window is set, and the window's onload-event is triggered). The timer also keeps an average if you execute the same query repeatedly.<br /><br />

			Click the <span class="help-highlight">output hashes</span> link to bring up a list of output hashes. Each time you run a query, a hash of the resulting output is printed, providing an easy way to quickly see whether the results of two subsequent queries differ. The hashes themselves have no meaning.<br /><br />

			Toggle <span class="help-highlight">enable Ctrl+s</span> to enable the use of ctrl+s for saving of the current query (content of the query window), using the name of the currently highlighted saved query (= the last one you loaded or saved). Be aware, the program overwrites the stored query without warning, and there's no undo. Functionality is turned off by default.<br /><br />

		</p>
		<p>
			<span class="section-header">Key bindings</span>
			<ul>
				<li>F2: open help-window (and close it again).</li>
				<li>Esc: close help- and links-windows.</li>
				<li>Ctrl+enter: run query.</li>
				<li>Ctrl+space: insert <span class="ctrl-space-number-of-spaces">2</span> spaces at cursor in query window.</li>
				<li>Ctrl+F7: clear <span class="help-highlight">query</span>.</li>
				<li>Ctrl+F8: set focus on <span class="help-highlight">query</span>.</li>
				<li>Ctrl+F9: set focus on <span class="help-highlight">type to find field name</span>.</li>
				<li>Ctrl+F11: insert comment char <code class="active-comment-char"></code> at the beginning of the line in the query-window (works on multiple selected lines).</li>
				<li>Ctrl+Shift+F11: remove comment char <code class="active-comment-char"></code> from begin of selected lines in the query-window.</li>
				<li>Ctrl+F12: encloses selected text in query-window in double quotes; works with multiple words.</li>
				<li>Alt+Del: clear the <span class="help-highlight">result window</span>.</li>
				<li>Ctrl+clicking <span class="help-highlight">copy query</span>: dump info to browser console as well (works for all 'copy to clipboard' commands).</li>
				<li>Ctrl+clicking <span class="symbol link min-width-symbol">&#10229;</span>: immediately run query after loading.</li>
				<li>Ctrl+clicking <span class="help-highlight">add slashes</span>: also removes newlines & multiple spaces.</li>
				<li>Shift+clicking <span class="help-highlight">add slashes</span>: removes slashes from \".</li>
				<li>Ctrl+clicking datamodel entry: encloses value in double quotes when inserting.</li>
				<li>Ctrl+s: save current query with highlighted query-name (disabled by default).</li>
				<li>Shift+&#128203;: also copy query(group) name to clipboard while copying it to the new name input.</li>
				<li>AltGr+F9: inserts the "size 100 (stand alone clause)" code bit in the query window.</li>
				<li>AltGr+F10: inserts basic query template in the query window.</li>
			</ul>

			When service select list is active, press a key to:

			<ul>
				<li>s: jump to the first entry of the specimen-services in the service list.</li>
				<li>t: idem for the taxon services.</li>
				<li>m: idem for the multimedia services.</li>
				<li>g: idem for the geo services.</li>
				<li>d: idem for the metadata services.</li>
				<li>y: idem for the system services.</li>
				<li>v: idem for the static services.</li>
			</ul>
		</p>
		<p>
			<span class="section-header">About <span class="appName"></span></span>
			This tool comes "as is". It was originally developed using Firefox 54.x, later in Chromium. This is version <span class="appVersion"></span> (<span class="appDate"></span>).
			<!-- <A href="" class="email appEmail">Suggestions for improvement are appreciated!</a> -->
		</p>

		<p class="versionHistory">
			<span class="section-header">version history</span>
			<ul id="version-history">

				<li class="v3.17">
 					v3.17 (2022.04.11)
 					<span class="content">
 						Added monospace to CSS.
 						Added share-button for copying link to Scratchpad including query.
 						Ctrl+clicking once again adds quotes to inserted field names.
 						Changed keyboard service select to pressing keys (s,t,g,m,d,y,v) when service select list is active, rather than AltGr-combinations.
 						Error message has max width plus hidden overflow to avoid displacement.
 						Longitude and latitude are clickable, opening Google Maps with the corresponding coordinates. When only latitude or only longitude is present, the missing coordinate is assumed to be zero.
 						Ctrl+double clicking a key of a document in the resultset copies that key and its value(s) as a JSON-object to the clipboard.
					</span>
				</li>

				<li class="v3.16.2">
 					v3.16.2 (2021.07.22)
 					<span class="content">
 						Fixed payload conversion bug in proxy (NBAX-532, 2nd part)
					</span>
				</li>

				<li class="v3.16.1">
 					v3.16.1 (2021.07.21)
 					<span class="content">
 						Fixed double-nested sortFields bug (NBAX-531).
 						Added insert basic query template by pressing AltGr+F10.
					</span>
				</li>

				<li class="v3.16">
 					v3.16 (2021.06.23)
 					<span class="content">
 						"Stuck Ctrl-key" now automatically released when switching (blurring) windows, and when initial load completes (same for Shift and AltGr).
 						All types of errors are now displayed formatted correctly.
 						Full name of saved queries is now clickable (finally).
 						Fixed last entry check of session history (caused consecutive identical entries).
 						Fixed 'cut not working' bug.
 						Size indicator now shows the number of elements in the document for results with a single level (like those from a distinct query).
 						Max. columns in tabular view set to 100 (from 50), which allows most results to fit in their entirety without serious impact on performance; header interval now set to 25 (from 50).
 						http-links in JSON-output now also clickable (some left in CoL).
 						http(s)-links in tabular output clickable.
					</span>
				</li>

				<li class="v3.15">
 					v3.15 (2021.04.30)
 					<span class="content">
 						Session query history, remembers last 100 queries from session (link next to 'saved queries') (NBAX-425).
 						Query maintenance page for reordering and renaming queries and query groups (link in 'more options').
 						Links in output now clickable (JSON only).
 						"Hanging" Ctrl-key workaround (automatically resets to "up" after 10 seconds).
 						Resizing query window automatically resizes result window to fit screen.
 						Query window content is now trimmed before evaluated as empty for default query.
 						Clipboard copy of rotated output is now also rotated (bug fix).
 						countDistinct*-endpoints accept _querySpec (bug fix).
					</span>
				</li>

				<li class="v3.14">
 					v3.14 (2021.03.31)
 					<span class="content">
 						Displayed JSON-result is capped on 1MB, number of records rounded down to the nearest multiple of 10; table-view displays the same records; downloads are unaffected (NBAX-495).
 						'New window'-switch looks at what the service produces (zip & x-ndjson) (NBAX-494).
 						Single-level arrays are displayed correctly in table-view (NBAX-493).
 						Added full screen results option (&#9974;; Esc closes).
	 					Can rotate tabular data (NBAX-492).
	 					Services class correctly handles 'produces'-array (NBAX-444).
					</span>
				</li>

				<li class="v3.13">
 					v3.13 (2021.03.04)
 					<span class="content">
	 					Added tabular data and .tsv-download.
	 					Fixed non-updating record total in 'next batch'-function.
	 					Log info form explain-query now appears in a dialog, JSON-result is treated like proper data.
	 					Refactored and sanitized all libraries, implementing classes and namespaces.
	 					Added User-Agent header to proxy.
	 					Took out option of saving queries without service.
	 					"Run altered query" button is disabled until query/URL is actually altered.
	 					Messages on JSON parse errors are clickable, positioning the cursor at the location of the error.
						Reduced the list of allowed operators in field-suggestion to a more compact format.
					</span>
				</li>
				<li class="v3.12">
					v3.12 (2020.12.02)
					<span class="content">
	 					Fixed double [*]-selector in JSONpath input (NBAX-432).
						Added "content-type:application/json" for POST-requests with an empty body to avoid HTTP 415-errors (NBAX-427).
						Gave total result size more emphasis (NBAX-433).
						Replaced internal NBA URL in error reporting from proxy (NBAX-434).
						URL-window now correctly shows follow-up token requests (NBAX-428).
						Moved JSONpath input box to JSONpath dialog (NBAX-431).
						Added short JSONpath explanation and examples.
						Changed POST-requests in proxy to content-type 'application/json', now ignoring endpoints that consume 'application/x-www-form-urlencoded'.
						Removed simple type-duplicates of nameResolution- and batchQuery-requests.
						Fixed broken queries for {id}-style endpoints (NBAX-441).
						Now also parsing total result size from the debug ( __explain) output.
						Replaced automatic opening of requests with unhandled content-type replies (like 'application/x-ndjson') by a clickable link.
					</span>
				</li>
				<li class="v3.11">
					v3.11 (2020.11.09)
					<span class="content">
						Removed PURL-requests. Fixed 'always GET'-bug (oops), plus override in the proxy. Also added possibility of choosing method in the GUI. Inferred services are tested on loading. Added 'explain' option (for services that can handle it), including choice of level. Added service summaries (as mouseover-title in the services dropdown). Added 'next batch' button for batch queries (recognizes token in result). Added result download (including custom name and auto-increment counter). Added compression on all traffic from and to the proxy.<br />
						Interface fixes: replaced iframe with object (for non-JSON responses). Added total result size (even if there's none). Tidied service list. Took out access keys (patchy browser support). Result window now fits the screen w/o scrolling. Long saved query lists can now be scrolled. Context menu (right click) in query window now has proper 'insert elements into queries'-options (rather than just pasting). Replaced 'add slashes' with 'format query' ('add slashes' is still available in context menu). Ctrl + 'format query' gives a more compact format. Added searchType-operators for nameResolutionRequest to query window context menu.<br />
						Replaced original example queries with a set of more illustrative examples.
					</span>
				</li>
				<li>
					v3.10 (2020.05.18)
					<span class="content">AltGr+F9 inserts size clause code. Fixed XJSON-window top. Fixed autobackup bug. Fixed notes window positioning bug. Changed 're-use (group)name'-icon, name is also copied to console.
					</span>
				</li>
					<li>v3.9 (2020.03.04)
					<span class="content">added skip/overwrite/append-option to query import. auto cleanup of orphaned notes. added monthly auto-backup of queries. fixed "2nd attempt query-import not responding"-bug. replaced shoddy 'run query'-arrows. removed dead F4-toggle and old server-select code. updated Jira code-tags. added query list toggle. added links to help dialog.
					</span>
				</li>
				<li>
					v3.8 (2019.12.19)
					<span class="content">added support for "mixed content" aggregate queries. fixed 'undefined' bug in operator list. added more informative placeholders to query-window. removed 'suppress output' option. removed groupBy-query code examples. refactored underlying container.
					</span>
				</li>
				<li>
					v3.7 (2019.02.12)
					<span class="content">AltGr+F1/F2/F3/F4/F5 to jump to the first entry in the service list of the specimen-services, the taxon-services, etc.</span>
				</li>
				<li>
					v3.6 (2018.12.28)
					<span class="content">downloads are always forced in new tab. query file import repeat bug fixed. fixed month in save file name.</span>
				</li>
				<li>
					v3.5 (2018.11.07)
					<span class="content">added 'quick queries download' option plus import of backups via file.</span>
				</li>
				<li>
					v3.4-server (2018.09.05)
					<span class="content">fixed declaration of 'download' services.</span>
				</li>
				<li>
					v3.3-server (2017.10.23)
					<span class="content">added loading of external query through _querySpec parameter.</span>
				</li>
				<li>
					v3.2-server (2017.10.03)
					<span class="content">migrated to server. stripped multi-server capabilities.</span>
				</li>
				<li>
					v3.2 (2017.09.05)
					<span class="content">operator list is generated automatically. added XPath for JSON functions. small fixes.</span>
				</li>
				<li>
					v3.1 (2017.07.18)
					<span class="content">added grouping in context code menu. added 'noServices' option to servers.</span>
				</li>
				<li>
					v3.0 (2017.06.14)
					<span class="content">Added some access keys. added <code>custom-styles.css</code> option. added query execution timer. Ctrl+space inserts multiple spaces. added querywindow context menu toggle (so you can turn off the browser's spelling checker). added Ctrl+s. added Shift+add slashes. added possibility of extra static services (in <code>config.js</code>), including option for non-standard port (for PURL). added different result window for cross-domain-enabled servers, incl. copying and searching in results. implemented direct server requests for all ajax services, with proxy as backup. added support for non-JSON and -html responses. added manual setting of accept headers. added GET/POST-switch. added http response code monitor. added possibility of suppressing output (useful for better query timing). added output hashes (to quicky see if output has changed). bugfixes.</span>
				</li>
				<li>
					v2.10 (2017.05.15)
					<span class="content">removes "just brackets" query before executing a human readable service. version-info is retrieved from this table. user can (de)select query-groups. query names are htmlEncoded before being saved. allows for default list of services from file for situations in which the proxy cannot be reached.</span>
				</li>
				<li>
					v2.9 (2017.05.09)
					<span class="content">non-indexed fields are now excluded from document field search (including toggle). only searchable document fields that correspond with the selected service are shown (can be overridden). services are retrieved automatically from the server. page-elements are temporarily disabled while loading. bugfixes.</span>
				</li>
				<li>
					v2.8 (2017.05.01)
					<span class="content">doubleclick copy query encloses the copied query in {code} tags for JIRA. Alt+F11 removes comment chars.  moved code & operator selects to query window context menu. before executing, application removes superfluous comma's from the query. query is verified as valid JSON or not executed (can be overridden in <code>config.js</code>). cursor position (line, column) is displayed below the query-window (helps debugging JSON parse errors). list of document fields, allowed operators and analyzers is now retrieved dynamically from the selected server (through a remote proxy, for now). added 'search in Google' to query window context menu.</span>
				</li>
				<li>
					v2.7 (2017.03.27)
					<span class="content">Ctrl+F11 inserts comment char in query-window, Ctrl+F12 encloses selected text in double quotes. Ctrl+F11 now also works on multiple selected lines. Ctrl+click datamodel entry adds "'s around inserted value. moved code- & operator-insert event to option onclick, so subsequent clicks on the same option also work. made config.js file entirely optional (all vars have defaults), added noExampleQueries option. datamodel-'type as you find' now works with partial & space-split search terms. Ctrl+F9 sets focus to field search input. fixed double-quote repeating strings enclosure bug.</span>
				</li>
				<li>
					v2.6.1 (2017.03.10)
					<span class="content">Ctrl+add slashes also removes newlines & multiple spaces.</span>
				</li>
				<li>
					v2.6 (2017.03.10)
					<span class="content">added datamodels & field-insert. removed 'insert' links from code bits and operator selectors.</span>
				</li>
				<li>
					v2.5 (2017.03.09)
					<span class="content">added query export, import and bulk deletion.</span>
				</li>
				<li>
					v2.4.4 (2017.03.02)
					<span class="content">added optional target to useful links. added additional tool <code>parse-mapping.html</code>. added 'add slashes'.</span>
				</li>
				<li>
					v2.4.3 (2017.03.01)
					<span class="content">seperated config.js and services.js.</span>
				</li>
				<li>
					v2.4.2 (2017.02.09)
					<span class="content">added labels for links window.</span>
				</li>
				<li>
					v2.4.1 (2017.01.31)
					<span class="content">Alt+up/down changes selected server; Alt+delete clears the result window, plus link for the same; Ctrl+enter now works globally; escape closes help-window; added decode query function.</span>
				</li>
				<li>
					v2.4 (2017.01.26)
					<span class="content">removed index numbers from, and added templates to server & service lists; added URL-awareness in notes' text; notes automatically change when a query is selected; notes window draggable; enabled copy to clipboard for query plus parameters; various  small changes.</span>
				</li>
				<li>
					v2.3.4 (2017.01.16)
					<span class="content">fixed server status toggle bug.</span>
				</li>
				<li>
					v2.3.3 (2017.01.12)
					<span class="content">added Ctrl+click = load & execute.</span>
				</li>
				<li>
					v2.3.2 (2017.01.09)
					<span class="content">moved message area to avoid width-issues; small style changes.</span>
				</li>
				<li>
					v2.3.1 (2017.01.09)
					<span class="content">fixed nested query arrow bug.</span>
				</li>
				<li>
					v2.3 (2017.01.08)
					<span class="content">queries can be saved with corresponding service.</span>
				</li>
				<li>
					v2.2 (2017.01.05)
					<span class="content">added code bits and operators.</span>
				</li>
				<li>
					v2.1.1 (2017.01.05)
					<span class="content">corrections to help text, added links pop-up.</span>
				</li>
				<li>
					v2.1 (2016.12.13)
					<span class="content">included help text.</span>
				</li>
				<li>
					v1 &hellip; 2.0 (nov/dec. 2016)
					<span class="content">initial versions.</span>
				</li>
			</ul>
		</p>

		<p class="versionHistory" clear="all">
			<span class="section-header">known issues, bugs, ideas</span>
			<!-- some TODO's in the code itself -->
			<ul>
				<li>No paste option in query-window context menu.</li>
				<li>Non-indexed fields are absent from suggestion which prohibits them from being easily added the "fields" parameter.</li>
				<li>Field names with periods (like "identifications.defaultClassification.phylum") aren't clickable in JSONpath-screen.</li>
				<li>Check specified field names in query (condition and field-list) against list of available fields for that endpoint.</li>
				<li>Remember JSON or table-view as default (across sessions).</li>
				<li>Start using https://www.sitepoint.com/clipboard-api/ includes paste (and looks nice).</li>
				<li>Explain operators somewhere. Use notes.html?</li>
				<li>Separate inputs for {field}/{group}, name=value and full query (maybe; veers towards a query builder).</li>
				<li>Add non-searchable fields as non-clickable + "not indexed" in drop down.</li>
			</ul>
		</p>

		<p>
			<span class="section-header">links</span>
			<u>Netherlands Biodiversity API (NBA)</u><br/>
			<ul>
				<li><a href="https://docs.biodiversitydata.nl/en/latest/" target="_blank">Netherlands Biodiversity Data Services user documentation</a></li>
				<li><a href="https://docs.biodiversitydata.nl/endpoints-reference/" target="_blank">Netherlands Biodiversity API endpoint reference</a></li>
				<li><a href="https://github.com/ropensci/nbaR" target="_blank">NBA R-client</a></li>
				<li><a href="https://www.naturalis.nl/" target="_blank">Naturalis</a></li>
				<li><a href="https://bioportal.naturalis.nl/api" target="_blank">Naturalis BioPortal</a></li>
			</ul>
			<p>
				<u>Useful tools</u>
			</p>
			<ul>
				<li><a href="http://geojson.io/" target="_blank">geojson.io (plots GeoJSON on a world map)</a></li>
				<li><a href="http://goessner.net/articles/JsonPath/" target="_blank">JSONPath FAQ</a></li>
			</ul>
		</p>

	</div>

</div>
